-- PL/SQL creates a dedicated tablespace for the ticket_P table
-- and adds the needed datafiles depending on the size of the ticket table
DECLARE
file_nbr INTEGER := 1;
remainingSize INTEGER;
FileName VARCHAR2(500);
tomorrow VARCHAR2(10);
dayAfteromorrow VARCHAR2(10);
ntomorrow VARCHAR2(15);
ndayAfteromorrow VARCHAR2(15);
BEGIN
filename := '''/in/smf/service/storage/db/tck/hb211_ticket_' || TO_CHAR(file_nbr) || '.dbf''';
remainingSize := 60;
If remainingSize < 600 Then
    EXECUTE IMMEDIATE
    'create tablespace storage_logevent' || ' datafile ' || filename || 'size ' || remainingSize || 'M';
    remainingSize := 0;
Else
    EXECUTE IMMEDIATE
    'create tablespace storage_logevent' || ' datafile ' || filename || 'size 600M';
    remainingSize := remainingSize - 600;
    file_nbr := file_nbr + 1;
    filename := '''/in/smf/service/storage/db/tck/hb211_ticket_' || TO_CHAR(file_nbr) || '.dbf''';
END IF;
LOOP
  if remainingSize < 600 THEN EXIT;
  END IF;
  EXECUTE IMMEDIATE 'alter tablespace storage_logevent add datafile' || filename || 'size 600M';
  remainingSize := remainingSize - 600;
  file_nbr := file_nbr + 1;
  filename := '''/in/smf/service/storage/db/tck/hb211_ticket_' || TO_CHAR(file_nbr) || '.dbf''';
 END LOOP;
IF 0 <> remainingSize THEN
  EXECUTE IMMEDIATE 'alter tablespace storage_logevent add datafile ' || filename || ' size ' || remainingSize || 'M';
END IF;
COMMIT;
tomorrow := TO_CHAR(TRUNC(SYSDATE) + 1, 'DDMMYYYY');
dayAfteromorrow := TO_CHAR(TRUNC(SYSDATE) + 2, 'DDMMYYYY');
SELECT TO_CHAR(((86400*(TRUNC(SYSDATE) + 1 - TO_DATE('01011970','DDMMYYYY')))-876543210),'9999999999') INTO ntomorrow from dual;
SELECT TO_CHAR(((86400*(TRUNC(SYSDATE) + 2 - TO_DATE('01011970','DDMMYYYY')))-876543210),'9999999999') INTO ndayAfteromorrow from dual;
-- create the logevent table in the service tablespace with two initial partitions
EXECUTE IMMEDIATE 'CREATE TABLE ticket_P (ri NUMBER(10),
          tkey VARCHAR2(32), 
          evttype CHAR, 
          snpupdt NUMBER(10),
          bdate NUMBER(10),
          srvid CHAR,
          extra1 NUMBER(10),
          extra2 VARCHAR2(20),
          asndata VARCHAR2(4000))
TABLESPACE storage_logevent
STORAGE (NEXT 5M INITIAL 5M MINEXTENTS 1 MAXEXTENTS 10 PCTINCREASE 0) PCTFREE 5
PARTITION BY RANGE (snpupdt)
(PARTITION ecd_' || tomorrow || ' VALUES LESS THAN (' || ntomorrow || '),
 PARTITION ecd_' || dayAfteromorrow || ' VALUES LESS THAN (' || ndayAfteromorrow || '))';
COMMIT;
EXECUTE IMMEDIATE 'CREATE SYNONYM ecd_' || tomorrow || ' for ticket_P';
EXECUTE IMMEDIATE 'CREATE SYNONYM ecd_'  || dayAfteromorrow || ' for ticket_P';
END;
.
/
-- add access rights and synonym needed by the platform
GRANT SELECT ON ticket_P TO PUBLIC; 
CREATE SYNONYM S_ticket for ticket_P;
CREATE VIEW ticket AS SELECT * FROM ticket_P;
CREATE SEQUENCE riseq MAXVALUE 4294967295 CYCLE CACHE 5000;
CREATE SYNONYM EVTMISC for ticket_P;
CREATE SYNONYM S_EVTMISC for ticket_P;
CREATE SYNONYM EVTMISC_P for ticket_P;
exit;
